Subject: Re: napi driver for multiport device with the only one dma channel - is it possible?

From: Stephen Hemminger <[email-masked]>
Date: Thu, 13 Dec 2018 10:18:32 -0800

On Thu, 13 Dec 2018 13:30:50 +0000
Jan Petrous <[email-masked]> wrote:

> Hi,
> 
> am I understand it right that I can not use NAPI-powered design in case
> when there is only one rx queue and one tx queue (only two
> dma channels) usable for data transfer with the ethernet controller for
> all interfaces (2 ports or more)?
> 
> I could imagine there would be possibility to declare for example rx
> queue sharable between napi interfaces, but I was not able to find
> anything like that.
> 
> I agree that it is a bit strange configuration but we have to support
> such corner case (when other dma channels are used by independent
> systems).
> 
> I seems like I have to create two drivers - one with napi, when at
> least the same number of dma channels are free for use and second one
> without napi (because of not enough dma channels).
> 
> 
> Thanks.
> /Jan

It is possible. Sky2 for some hardware has a single NAPI (on port 0)
and if the card is dual port the napi of port 0 is used by port 1.